#include <stdio.h>
#include "ABB.h"

//funo para criar/inicializar a rvore de busca binria
void criar(ABB *A) {
     *A=NULL;
}

//funo para finalizar rvore de busca binria; deve comear com p=raiz
void finalizar(ABB *p) {
     if (*p!=NULL) {
        finalizar(&(*p)->esq);
        finalizar(&(*p)->dir);
        free(*p);
     }
}

//imprime os elementos da rvore
void imprimir(ABB p) {
     if (p!=NULL) {
        printf("%d(", p->info);  
        imprimir(p->esq);
        printf(",");
        imprimir(p->dir);
        printf(")");
     }
     else printf("null");
}

//funo de busca de um elemento na rvore binria de busca; deve comear com p=raiz
int buscar(ABB p, elem x) {
    if (p==NULL)
       return 0;
    else if (x < p->info)
         return(buscar(p->esq,x));
    else if (x > p->info)
         return(buscar(p->dir,x));
    else return 1;
}


//funo de insero de um elemento na rvore binria de busca; deve comear com p=raiz
int inserir(ABB *p, elem x) {
     if (*p==NULL) {
        *p=(no*) malloc(sizeof(no));
        (*p)->info=x; 
        (*p)->esq=NULL;
        (*p)->dir=NULL;
        return 1;
     }
     else if (x<(*p)->info)
          return(inserir(&(*p)->esq,x));
     else if (x>(*p)->info)
          return(inserir(&(*p)->dir,x));
     else return 0;
}

